# As for ht1 but combines all surface species for a given redox state (secondary master species) into one
# eg Surf-As(3), Surf-As(5)
# Thanks to Rémi Marsac (INE) for the suggestion

PRINT
   -reset false
   
SELECTED_OUTPUT
   -high_precision true
   -reset false
   
USER_PUNCH
10 main$ = "<mainspecies>"
20 IF (STEP_NO = 0) THEN 630
25 REM First get predominant species EXCLUDING surface species (and gases)
30 nout1 = 0
40 totel = SYS(main$, n, n$, t$, moles)
50 h2o = TOT("water")
60 FOR i = 1 TO n
70   IF (moles(i) <= 0) THEN 200
80   IF (t$(i) = "surf") THEN 140
100  IF (INSTR(n$(i), "(g)") > 0) THEN 140
110  PUNCH n$(i), moles(i)/h2o
111  PRINT n$(i), moles(i)/h2o
120  nout1 = nout1 + 1
130  IF(nout1 >= 3) THEN 200
140 NEXT i

160 REM loop through valence states involved, say -8 to +8
170 REM They should come sorted in abundance from SYS()
180 REM PUNCH them out and PhreePlot will resort the whole lot
190
200 DIM s(17)
205 FOR j = 1 TO 17
210   i = ABS(j - 9)
220   elv$ = main$ + "(" + TRIM(STR$(i)) + ")"
225   s(j) = SYS(elv$, ne, n$, t$, moles)
226   REM PRINT PAD(elv$,6), "ns(j)= ", ns(j)
235   totads = 0
240   IF (s(j)<=0) THEN 280
245   FOR k = 1 TO ne
255      if (t$(k)='surf') THEN totads = totads + moles(k)
260   NEXT k
265   IF (totads <= 0) THEN 280
270   PUNCH "Surf" + "-" + main$ + "(" + CHR$(i+48) + ")", totads
275   nout1 = nout1 + 1
280 NEXT j

500 nout3 = 0
505 IF (SI("H2(g)") > 0) THEN 510 ELSE 530
510 PUNCH "H2(g) > 1 atm", 10^SI("H2(g)")
520 nout3 = nout3 + 1
530 IF (SI("O2(g)") > 0) THEN 540 ELSE 560
540 PUNCH "O2(g) > 1 atm", 10^SI("O2(g)")
550 nout3 = nout3 + 1
560 IF (SI("CH4(g)") > 0) THEN 570 ELSE 590
570 PUNCH "CH4(g) > 1 atm", 10^SI("CH4(g)")
580 nout3 = nout3 + 1

590 nout4 = 0

600 PUNCH "pH", -LA("H+"), "pe", -LA("e-"), "PO2", SI("O2(g)"), "PH2", SI("H2(g)"), "TC", tc
610 nout5 = 5
620 PUNCH nout1, nout2, nout3, nout4, nout5
630 END

